/*
 * ******************************************************************************************
 * File		: main.c
 * Author 	: GowinSemicoductor
 * Chip		: AE350_SOC
 * Function	: Main functions
 * ******************************************************************************************
 */

// Includes ---------------------------------------------------------------------------------
#include "ram.h"
#include "uart.h"
#include "delay.h"
#include <stdio.h>


// Definitions ------------------------------------------------------------------------------

// Application entry function
int main(void)
{
	//----------------------------------- 1 ------------------------------------------//
    uart_init(38400);	// Initializes UART3

    printf("\r\nIt's an AHB to AHB 16 Bridge (Slave 1 and Slave 2) demo.\r\n");
    printf("These are RAM1 and RAM2 demos.\r\n");

    printf("\r\n\r\n\r\n");
    printf("\r\n*************************************************************************\r\n");
    printf("*************************************************************************\r\n");
    printf("*************************************************************************\r\n");
    printf("\r\n\r\n\r\n");

    printf("\r\n- - - - - - - - - - - - - - - - - - - - - - - - - - - \r\n");
    printf("Slave 1: RAM1...\r\n");

    for(int i = 0; i < 100; i++)
    {
    	printf("\r\n- - - - - - - - - - - - - - - - - - - - - - - - - - - \r\n");
    	printf("Loop %d\r\n", i);

    	// Write data into RAM1
    	printf("Write data into RAM1...\r\n");
    	setDataCmd(DEV_RAM1, 3);		// Command: select and write
    	setDataAddr(DEV_RAM1, i);		// Address
    	setDataIn(DEV_RAM1, 230+i);		// Data input

    	// Read data from RAM1
    	printf("Read data from RAM1...\r\n");
    	setDataCmd(DEV_RAM1, 2);		// Command: select and read
    	printf("Address    : %d\r\n",getDataAddr(DEV_RAM1));
    	printf("Data input : %d\r\n",getDataIn(DEV_RAM1));
    	printf("Data output: %d\r\n",getDataOut(DEV_RAM1));

    	simple_delay_ms(1000);
    }

    printf("\r\n\r\n\r\n");
    printf("\r\n*************************************************************************\r\n");
    printf("*************************************************************************\r\n");
    printf("*************************************************************************\r\n");
    printf("\r\n\r\n\r\n");

    printf("\r\n- - - - - - - - - - - - - - - - - - - - - - - - - - - \r\n");
    printf("Slave 2: RAM2...\r\n");

    for(int i = 0; i < 100; i++)
    {
    	printf("\r\n- - - - - - - - - - - - - - - - - - - - - - - - - - - \r\n");
    	printf("Loop %d\r\n", i);

    	// Write data into RAM2
    	printf("Write data into RAM2...\r\n");
    	setDataCmd(DEV_RAM2, 3);		// Command: select and write
    	setDataAddr(DEV_RAM2, i);		// Address
    	setDataIn(DEV_RAM2, 230+i);		// Data input

    	// Read data from RAM2
    	printf("Read data from RAM2...\r\n");
    	setDataCmd(DEV_RAM2, 2);		// Command: select and read
    	printf("Address    : %d\r\n",getDataAddr(DEV_RAM2));
    	printf("Data input : %d\r\n",getDataIn(DEV_RAM2));
    	printf("Data output: %d\r\n",getDataOut(DEV_RAM2));

    	simple_delay_ms(1000);
    }

    printf("\r\n\r\n\r\n");
    printf("\r\n*************************************************************************\r\n");
    printf("*************************************************************************\r\n");
    printf("*************************************************************************\r\n");
    printf("\r\n\r\n\r\n");

    printf("PASS.");

    return 0;
}
